package pc.javier.actualizadoropendns.control.difusion;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;

import java.util.Date;

import pc.javier.actualizadoropendns.adaptador.Preferencias;
import pc.javier.actualizadoropendns.adaptador.Servidor;
import pc.javier.actualizadoropendns.control.EnlaceEventos;
import utilidades.InfoInternet;
import utilidades.MensajeRegistro;

/**
 * Javier 2019.
 */

public class ConexionInternet extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        Preferencias preferencias = new Preferencias(context);
        if (preferencias.getUsuario().isEmpty())
            return;





        long horaGuardada = preferencias.getUltimaActualizacion();
        Long ahora = new Date().getTime();
        int intervalo = 60 * 10;


        if (new Date(horaGuardada + (1000 * intervalo)).getTime() - ahora > 0 ) {
            MensajeRegistro.msj ("muy pronto para actualizar");
            return;
        }
        preferencias.setultimaActualizacion(ahora);



        InfoInternet infoInternet = new InfoInternet(context);

        mensajeLog("cambios en la conexion");

        if (!infoInternet.conectado())
            return;

        mensajeLog ("tipo: " + infoInternet.getTipo()); // tipo de red (wifi)
        mensajeLog ("extra info: " + infoInternet.getInfo()); // nombre de red wifi







        EnlaceEventos enlaceEventos = new EnlaceEventos(context);
        Servidor servidor = new Servidor(context);
        servidor.setEvento(enlaceEventos.obtenerEventoConexionServidor());
        servidor.enviar();

    }



    /*
    @Override
    public void onReceive(Context context, Intent intent) {
        final ConnectivityManager conexion = (ConnectivityManager) context
                .getSystemService(Context.CONNECTIVITY_SERVICE);


        final NetworkInfo infoRedes = conexion.getActiveNetworkInfo();


        mensajeLog ("cambio de internet");

        if (infoRedes == null)
            return;

        mensajeLog ("Existe una conexión");

        if (infoRedes.isConnected())
            mensajeLog ("¡Está conectado!");
        else
            return;

        mensajeLog ("tipo: " + infoRedes.getTypeName()); // tipo de red (wifi)
        mensajeLog ("extra info: " + infoRedes.getExtraInfo()); // nombre de red wifi
        mensajeLog ("reason: " + infoRedes.getReason()); // nombre de red wifi


        Preferencias preferencias = new Preferencias(context);
        if (preferencias.getUsuario().isEmpty())
            return;



        EnlaceEventos enlaceEventos = new EnlaceEventos(context);
        Servidor servidor = new Servidor(context);
        servidor.setEvento(enlaceEventos.obtenerEventoConexionServidor());
        servidor.enviar();

    }
    */

    private void mensajeLog (String texto) {
        MensajeRegistro.msj (this, texto);
    }











}
