package pc.javier.actualizadoropendns.control.receptor;


import android.app.Activity;

import pc.javier.actualizadoropendns.R;
import pc.javier.actualizadoropendns.bd.BD;
import pc.javier.actualizadoropendns.control.Aplicacion;
import pc.javier.actualizadoropendns.vista.PantallaPrincipal;
import utilidades.ConexionHTTP;
import utilidades.FechaHora;
import utilidades.InfoInternet;


/**
 * Javier 2019.
 *  recibe estados de la conexion a internet
 */

public class ReceptorConexionInternet extends utilidades.ReceptorEventos {

    private PantallaPrincipal pantallaPrincipal;
    private BD bd;
    private InfoInternet infoInternet;

    public ReceptorConexionInternet(Activity activity, String clave) {
        super(clave);
        if (activity == null)
            activity = Aplicacion.actividadPrincipal;
        pantallaPrincipal = new PantallaPrincipal(activity);
        bd = new BD(activity);
        infoInternet = new InfoInternet(activity);
    }


    @Override
    public void procesar(String dato) {

        if (dato.equals(ConexionHTTP.Estado.Conectando.name())) {
            pantallaPrincipal.snack(R.string.conectando);
            pantallaPrincipal.dibujarBoton(false);
        }


        if (dato.equals(ConexionHTTP.Estado.Finalizado.name())) {
            pantallaPrincipal.dibujarBoton(true);
        }

        if (dato.equals(ConexionHTTP.Estado.Error.name())) {
            pantallaPrincipal.snack(R.string.errorconexion);
            pantallaPrincipal.dibujarBoton(true);
            FechaHora fechaHora = new FechaHora();
            String respuesta = pantallaPrincipal.getActivity().getString(R.string.errorconexion);
            String informacion = infoInternet.getTipo() + ": " +  infoInternet.getInfo();
            bd.abrir();
            bd.registroAgregar(fechaHora.obtenerHoraFechaNormal(), respuesta , informacion , 1);
            bd.cerrar();
        }

        if (dato.equals(ConexionHTTP.Estado.Recibiendo.name())) {

        }

        if (dato.equals(ConexionHTTP.Estado.Enviando.name())) {

        }

    }


}
