package utilidades.bdd;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import utilidades.MensajeRegistro;

/**
 * Javier 18/11/2016.
 * conexión a la base de datos
 */
public class BDConexion extends SQLiteOpenHelper {


    // conexión a la base de datos de la aplicación
    private Tabla tablas[];
    private int version;

    public BDConexion(Context context, Tabla[] tablas, int version) {
        super(context, "BaseDeDatos", null, version);
        this.tablas = tablas;
        this.version = version;
        mensajeLog("<<<< constructor >>>");

    }

    @Override
    public void onCreate(SQLiteDatabase sqLiteDatabase) {
        // sqLiteDatabase.execSQL(BDRegistro.TABLA);
        mensajeLog(" on create !!!!!!!!!!");
        crearTablas(sqLiteDatabase);
    }

    @Override
    public void onUpgrade(SQLiteDatabase sqLiteDatabase, int versionAnterior, int versionNueva) {
        mensajeLog(" RENOMBRA LA TABLA !!!!!!!!!!!!!!!!!!!!! ");
        renombrarTablas(sqLiteDatabase);
        crearTablas(sqLiteDatabase);
    }



    //
    private void renombrarTablas (SQLiteDatabase sqLiteDatabase) {
        mensajeLog("renombrar tablassss -> a continuación ejecutará script");
        for (Tabla tabla : tablas)
            renombrarTabla (sqLiteDatabase, tabla);
    }

    private void renombrarTabla (SQLiteDatabase sqLiteDatabase, Tabla tabla) {

        String comando = "ALTER TABLE " + tabla.getNombre() + " RENAME TO " + tabla.getNombre() + "copia" + version + " ;";

        mensajeLog(  "SCRIPT DE RENOMBRADO DE TABLAS : " + comando);
        try {sqLiteDatabase.execSQL(comando); }
        catch (Exception e) { mensajeLog(  "ERROR AL EJECUTAR: " + comando);}
    }


    // ------------------------


    private void crearTablas (SQLiteDatabase sqLiteDatabase) {
        mensajeLog("crear tablassss -> a continuación ejecutará script");
        for (Tabla tabla : tablas)
            crearTabla(sqLiteDatabase, tabla);
    }

    private void crearTabla (SQLiteDatabase sqLiteDatabase, Tabla tabla) {
        String comando = obtenerComandoCrear(tabla);
        mensajeLog("************  script:    " +  comando);
        sqLiteDatabase.execSQL(comando);
    }



    // ----------------------- creador de script

    private String obtenerComandoCrear (Tabla tabla) {
        return "Create Table if not exists "  + tabla.getNombre() + " (" + obtenerScriptTablas(tabla) + ");";
    }

    private String obtenerScriptTablas (Tabla tabla) {
        String tablaString = "";
        for (Columna columna: tabla.getColumnas()) {

                if (!tablaString.isEmpty())
                    tablaString = tablaString + ", ";
                tablaString = tablaString
                        + columna.getNombre()
                        + " "
                        + interpretarTipo(columna.getTipo());
            }

            return tablaString;
    }



    private String interpretarTipo (Columna.Tipo tipo) {
        switch (tipo) {
            case texto: return "text";
            case entero: return "int";
            case indiceAutomatico: return "integer primary key autoincrement";
        }
        return "text";
    }

    private void mensajeLog (String texto) {
        MensajeRegistro.msj (this, texto);
    }

}
